﻿class Program {

	static void Main(string[] args) {
		
		g1(new Person("John", "Doe"));
		g1(new Person("Petr", "Vesely"));
		g1(new Person("Jaroslav", "Vesely"));
		Console.WriteLine();

		g3(new PersonPlainClassDeconstructible { FirstName = "John", LastName = "Doe" });
		g3(new PersonPlainClassDeconstructible { FirstName = "Petr", LastName = "Vesely" });
		g3(new PersonPlainClassDeconstructible { FirstName = "Jaroslav", LastName = "Vesely" });
		g3(new PersonPlainClassDeconstructible { FirstName = "Pavel", LastName = "Jezek" });
		Console.WriteLine();

		h1(new int[] { 1, 2, 3, 4, 5, 6 });
		h1(new int[] { 5, 2, 3, 4, 5, 6 });
		h1(new int[] { 5, 1, 3, 4, 5, 6 });
	}

	record Person(string FirstName, string LastName);

	static int g1(Person p) {
		int result = p switch {
			Person("Petr", var lastName) => lastName.Length,
			Person(var firstName, "Vesely") => firstName.Length,
			_ => 0
		};

		Console.WriteLine(result);
		// Error: The name 'lastName' does not exist in the current context
		// Console.WriteLine(lastName);
		// Error: The name 'firstName' does not exist in the current context
		// Console.WriteLine(firstName;

		return result;
	}

	class PersonPlainClass {
		public string FirstName;
		public string LastName;
	}

	static void g2(PersonPlainClass p) {
		// Error: 'Program.PersonPlainClass' does not contain a definition for 'Deconstruct' and no accessible extension method 'Deconstruct'
		// accepting a first argument of type 'Program.PersonPlainClass' could be found(are you missing a using directive or an assembly reference ?)

		//int result = p switch {
		//	PersonPlainClass("Petr", var lastName) => lastName.Length,
		//	PersonPlainClass(var firstName, "Vesely") => firstName.Length,
		//	_ => 0
		//};
	}

	class PersonPlainClassDeconstructible {
		public string FirstName;
		public string LastName;

		public void Deconstruct(out string krestniJmeno, out string prijmeni) {
			krestniJmeno = FirstName;
			prijmeni = LastName;
		}

		public void Deconstruct(out int firstNameLength, out int lastNameLength, out string fullName) {
			firstNameLength = FirstName.Length;
			lastNameLength = LastName.Length;
			fullName = FirstName + " " + LastName;
		}
	}

	static void g3(PersonPlainClassDeconstructible p) {
		int result = p switch {
			PersonPlainClassDeconstructible(var len1, var len2, "Pavel Jezek") => len1 + len2 + 1000,
			PersonPlainClassDeconstructible("Petr", var lastName) => lastName.Length,
			PersonPlainClassDeconstructible(var firstName, "Vesely") => firstName.Length,
			_ => 0
		};

		Console.WriteLine(result);
	}

	static void h1(int[] numbers) {
		if (numbers is [> 3, < 2, .. var rest]) {
			for (int i = 0; i < rest.Length; i++) {
				Console.WriteLine(rest[i]);
			}

			Console.WriteLine($"numbers[2] == {numbers[2]}");
			Console.WriteLine($"rest[0] == {rest[0]}");
			Console.WriteLine(">>> rest[0] = 42");
			rest[0] = 42;
			Console.WriteLine($"numbers[2] == {numbers[2]}");
			Console.WriteLine($"rest[0] == {rest[0]}");
		} else {
			Console.WriteLine("No match!");
		}

		// Error: Use of unassigned local variable 'rest'
		// Console.WriteLine(rest);
	}
}
