﻿
class Progaram {

	static int AddEx(int? a, int? b) {
		Console.WriteLine("= AddEx");
		if (a is null) {
			throw new ArgumentNullException(nameof(a));
		}
		if (b is null) {
			throw new ArgumentNullException(nameof(b));
		}

		return a.Value + b.Value;
	}

	static int Alg1Ex(int? a, int? b, int? c, int? d) {
		Console.WriteLine("= Alg1Ex");
		return AddEx(a, b) * AddEx(b, c) * AddEx(c, d);
	}

	static bool TryAdd(int? a, int? b, out int result) {
		Console.WriteLine("+ TryAdd");
		if (a is null || b is null) {
			result = 0;
			return false;
		} else {
			result = a.Value + b.Value;
			return true;
		}
	}

	static bool TryAlg1(int? a, int? b, int? c, int? d, out int result) {
		Console.WriteLine("+ TryAlg1");
		result = 1;
		if (!TryAdd(a, b, out var r1)) {
			return false;
		}
		result = r1;

		if (!TryAdd(b, c, out var r2)) {
			return false;
		}
		result *= r2;

		if (!TryAdd(c, d, out var r3)) {
			return false;
		}
		result *= r3;

		return true;
	}

	static int? AddNullable(int? a, int? b) {
		Console.WriteLine("# AddNullable");
		return a + b;
	}

	static int? Alg1Nullable(int? a, int? b, int? c, int? d) {
		Console.WriteLine("# Alg1Nullable");
		return AddNullable(a, b) * AddNullable(b, c) * AddNullable(c, d);
	}

	public static void Main(string[] args) {
		Console.WriteLine("Scenario 1: 1, 2, 3, null");
		try {
			Alg1Ex(1, 2, 3, null);
		} catch (ArgumentNullException ex) {
			Console.WriteLine(">>> No result -> " + ex.Message);
		}
		if (!TryAlg1(1, 2, 3, null, out _)) {
			Console.WriteLine(">>> No result");
		}
		if (Alg1Nullable(1, 2, 3, null) is null) {
			Console.WriteLine(">>> No result");
		}

		Console.WriteLine();
		Console.WriteLine("Scenario 2: null, null, null, null");
		try {
			Alg1Ex(null, null, null, null);
		} catch (ArgumentNullException ex) {
			Console.WriteLine(">>> No result -> " + ex.Message);
		}
		if (!TryAlg1(null, null, null, null, out _)) {
			Console.WriteLine(">>> No result");
		}
		if (Alg1Nullable(null, null, null, null) is null) {
			Console.WriteLine(">>> No result");
		}
	}
}
