﻿using System;

namespace NezarkaBookstore {
	
	class Program {
		private static void Main(string[] args) {
			var reader = Console.In;

			var store = ModelStore.LoadFrom(reader);
			if (store is null) {
				Console.WriteLine("Data error.");
				return;
			}

			var masterController = new MasterController(
				store,
				new BooksController(
					store,
					new BooksViewFactory(),
					new BooksDetailViewFactory()
				),
				new ShoppingCartController(
					store,
					new ShoppingCartViewFactory()
				),
				new MasterViewFactory(),
				new MenuViewFactory()
			);

			var writer = Console.Out;

			string? line;
			while ((line = reader.ReadLine()) is not null) {
				masterController.ExecuteRequest(line, writer);
				writer.WriteLine("====");
			}
		}
	}

}
