﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace NezarkaBookstore {
	struct ViewOrError {
		private object _value;

		public ViewOrError(IView view) {
			_value = view;
		}

		public ViewOrError(Error error) {
			_value = error;
		}

		public bool HasView => _value is IView;

		public IView? View =>
			_value switch {
				IView view => view,
				_ => null
			};

		public Error? Error => 
			_value switch {
				Error error => error,
				null => NoResultSetError.Instance,
				_ => null
			};
	}

	abstract record class Error { }

	record class NoResultSetError : Error {
		public static readonly NoResultSetError Instance = new NoResultSetError();
	}

	record class InvalidActionError(string Action) : Error { }
}
