﻿namespace GcdEuclideanAlgorithmExceptions {
	internal class Program {

		static int GreatestCommonDivisor(int a, int b) {
			if (a <= 0) {
				throw new ArgumentOutOfRangeException(nameof(a), "Must be greater or equal to 1.");
			}
			if (b <= 0) {
				throw new ArgumentOutOfRangeException(nameof(b), "Must be greater or equal to 1.");
			}

			while (a != b) {
				if (a > b) {
					a -= b;
				} else {
					b -= a;
				}
			}

			return a;
		}

		static void Main(string[] args) {
			
			try {
				Console.WriteLine(GreatestCommonDivisor(0, 9));
			} catch (Exception e) {
				Console.WriteLine(e);
			}
			Console.WriteLine();
			try {
				Console.WriteLine(GreatestCommonDivisor(12, -9));
			} catch (Exception e) {
				Console.WriteLine(e);
			}
			Console.WriteLine();
			Console.WriteLine(GreatestCommonDivisor(12, 9));
			Console.WriteLine();
			
		}
	}
}