﻿namespace DeconstructInheritance {

	interface I1 { }

	class A : I1 {
		public string Name { get; set; }

		public void Deconstruct(out string name) {
			name = Name;
		}
	}

	class B : A { }

	class C : I1 {
		public int Value { get; set; }

		public void Deconstruct(out int value) {
			value = Value;
		}
	}

	class D : I1 { }

	class Program {

		static void MatchI1(I1? i1) {
			switch (i1) {
				case A("Pavel"):
					Console.WriteLine("case 1");
					break;
				case B("Petr"):
					Console.WriteLine("case 2");
					break;
				case C(123):
					Console.WriteLine("case 3");
					break;
				case A:
				case C:
					Console.WriteLine("case 4");
					break;
				default:
					Console.WriteLine("default case");
					break;
			}
		}

		static void Main(string[] args) {
			MatchI1(new A { Name = "Pavel" });
			MatchI1(new A { Name = "Petr" });
			MatchI1(new B { Name = "Pavel" });
			MatchI1(new B { Name = "Petr" });
			MatchI1(new A { Name = "Jaroslav" });
			MatchI1(new B { Name = "Jaroslav" });
			MatchI1(new C { Value = 123 });
			MatchI1(new C { Value = 42 });
			MatchI1(new D());
			MatchI1(null);
		}
	}
}